#include <windows.h>
#include <stdio.h>

/* uses WIN32 Threads */

static int c1,c2;

DWORD WINAPI P1(LPVOID data)
{
    for(;;)
    {
        while(c2==0);
        c1=0;    
        /*critical section*/
        printf("P1 enter\n");
        printf("P1 leave\n");
        c1=1;
        /*end critical section*/         
    }
    return 0;
}

DWORD WINAPI P2(LPVOID data)
{
    for(;;)
    {
        while(c1==0);
        c2=0;
        /*critical section*/
        printf("P2 enter\n");
        printf("P2 leave\n");
        c2=1;
        /*end critical section*/         
    }
    return 0;
}


int main()
{
    c1=c2=1;
    HANDLE h[2];
    h[0]=CreateThread(NULL,0,P1,NULL,0,NULL);
    h[1]=CreateThread(NULL,0,P2,NULL,0,NULL);
    if(INVALID_HANDLE_VALUE==h[0] || INVALID_HANDLE_VALUE==h[1])
    {
        fprintf(stderr,"Fehler beim CreateThread %x",GetLastError());
        exit(1);
    }
    getch();
    return 0;
}